var adPlaylistAPI = null;

function stopAdPlaylist() {
    adPlaylistAPI.stopAdPlaylist();
}

function getPlaylistError() {
    return JSON.stringify(adPlaylistAPI.error);
}

function getRawVMAP() {
    return adPlaylistAPI.rawVMAP;
}

function playVMAPWithURL(adURL, openerURL, forceOpener, closerURL, forceCloser, bumperURL, forceBumper, vastMacros, skipOffset, adVerificationConfigJSON) {
    console.log("playVMAPWithURL(" + adURL + ", " + openerURL + ", " + forceOpener + ", " + closerURL + ", " + forceCloser + ", " + bumperURL + ", " + forceBumper + ", " + vastMacros + ", " + skipOffset + ", " + adVerificationConfigJSON + ")");
    var skipOffsetInt = parseInt(skipOffset);
    if (skipOffsetInt > 0) {
        globalAdConfig.skipOffset = skipOffsetInt;
    }

    var adVerificationConfig = JSON.parse(adVerificationConfigJSON)
    globalAdConfig.adVerification.vendorWhitelist = adVerificationConfig['vendorWhitelist'];
    globalAdConfig.adVerification.playerHandles = true;

    var connectResult = smartclientcore.vmap.connect(myPlayerFacade);
    if (connectResult) {
        connectResult.setup(globalAdConfig).then(function ([playlistAPI, api]) {
                                                 adPlaylistAPI = playlistAPI;
                                                 adSlotAPI = api;
                                                 console.log('Ready to request and play out video ads.');
                                                 /**
                                                  * You are ready to request your first ads
                                                  * this is also a good point to subscribe to ad events
                                                  */
                                                 smartclientcore.EVENTS.forEach(eventType => {
                                                     adSlotAPI.addEventListener(eventType, (event) => {
                                                                                                          myPlayerFacade.onEventCallback(JSON.stringify(event));
                                                                                                          });
                                                                                });

                                                 var adPlaylistSetup = {
                                                    tag: adURL
                                                 };
                                                 adPlaylistSetup.preroll = {
                                                    opener: {
                                                        progressive: openerURL,
                                                        forcePlay: forceOpener
                                                    },
                                                 closer: {
                                                        progressive: closerURL,
                                                        forcePlay: forceCloser
                                                    },
                                                 bumper: {
                                                        progressive: bumperURL,
                                                        forcePlay: forceBumper
                                                    }
                                                 };

                                                 adPlaylistSetup.midroll = {
                                                 opener: {
                                                        progressive: openerURL,
                                                        forcePlay: forceOpener
                                                    },
                                                 closer: {
                                                        progressive: closerURL,
                                                        forcePlay: forceCloser
                                                    },
                                                 bumper: {
                                                        progressive: bumperURL,
                                                        forcePlay: forceBumper
                                                    },
                                                 prefetchOffset: 5
                                                 };
                                                 adPlaylistSetup.postroll = {
                                                 opener: {
                                                        progressive: openerURL,
                                                        forcePlay: forceOpener
                                                    },
                                                 closer: {
                                                        progressive: closerURL,
                                                        forcePlay: forceCloser
                                                    },
                                                 bumper: {
                                                        progressive: bumperURL,
                                                        forcePlay: forceBumper
                                                    },
                                                 prefetchOffset: 5
                                                 };

                                                 adPlaylistAPI.initAdPlaylist(adPlaylistSetup, JSON.parse(vastMacros)).then(function(adLoaded) {
                                                                                                                   console.log('### Loading AdManifest success.');
                                                     console.log(smartclientcore.EVENT);

                                                    adPlaylistAPI.startAdPlaylist();
                                                    resolve();
                                                                                                                   }, function(failedLoading) {
                                                                                                                   console.warn('### Loading AdManifest failed ' + failedLoading);
                                                                                                                   });

                                                 }, failure => {
                                                     console.log('setup failure: ' + failure);
                                                     reject(failure)
                                                 });
    } else {
        console.log('Error: connection error. connect returned null');
    }
}
